﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using DG.Tweening;
using UnityEngine.UI;

public class Computer : MonoBehaviour
{
    public Text[] Slots = new Text[9];
    public Text Result;
    private int[] values = new int[] { 1, 2, 3, 4, 5, 6, 7, 8, 9 };
    
    private int permNumber = 1;

    private bool computing = false;
    public bool found = false;
    public Text ButtonText;
  
    // Update is called once per frame
    void Update()
    {
        if (!computing && !found)
        {
            computing = true;
            int[] lastUsedPermutation = nextPerm(permNumber++);
            ButtonText.text = "("+ permNumber + ") next";
            Debug.Log("using now " + perToString(lastUsedPermutation));
            for (int i = 0; i < values.Length; i++)
            {
                Slots[i].text = lastUsedPermutation[i].ToString();
            }

            int result = (((((((((
                (lastUsedPermutation[0] + 13) *
                lastUsedPermutation[1]) /
                lastUsedPermutation[2]) +
                lastUsedPermutation[3]) + 12) *
                lastUsedPermutation[4]) -
                lastUsedPermutation[5]) - 11 +
               lastUsedPermutation[6]) *
               lastUsedPermutation[7]) /
               lastUsedPermutation[8]) - 10
                ;
            Result.DOFade(0, .01f).OnComplete(() =>
            {
                Result.text = result.ToString();
                Result.DOFade(1, .01f).OnComplete(() =>
                {
                    found = result == 66;
                    computing = false;
                });
            });
        }
    }

    string perToString(int[] perm)
    {
        string d = "";
        foreach (int i in perm)
        {
            d += i;
        }
        return d;
    }

    //from http://www.mathblog.dk/project-euler-24-millionth-lexicographic-permutation/
    private int Factor(int i)
    {
        if (i < 0)
        {
            return 0;
        }

        int p = 1;
        for (int j = 1; j <= i; j++)
        {
            p *= j;
        }
        return p;
    }

    private int[] nextPerm(int target)
    {
        int N = values.Length;
        int[] permNum = new int[9];
        int permNumIndex = 0;
        int remain = target - 1;

        List<int> numbers = new List<int>();
        for (int i = 0; i < N ;
        i++)
        {
            numbers.Add(values[i]);
        }

        for (int i = 1; i < N; i++)
        {
            int j = remain/Factor(N - i);
            remain = remain%Factor(N - i);
            permNum[permNumIndex] = numbers[j];
            permNumIndex++;
            numbers.RemoveAt(j);
            if (remain == 0)
            {
                break;
            }
        }

        for (int i = 0; i < numbers.Count; i++)
        {
            permNum[permNumIndex] = numbers[i];
            permNumIndex++;
        }
        return permNum;
    }

    public void NextSolution()
    {
        found = false;
    }
}
